package com.steerinfo.baseinfo.meterbasetimespace.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasetimespace.model.MeterBaseTimeSpace;
import com.steerinfo.baseinfo.meterbasetimespace.service.IMeterBaseTimeSpaceService;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;

/**
 * MeterBaseTimeSpace RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-06-17 09:02
 * 类描述
 * 修订历史：
 * 日期：2020-06-17
 * 作者：generator
 * 参考：
 * 描述：MeterBaseTimeSpace RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasetimespaces")
@Api(value = "/${api.version}/meterbasetimespaces", tags = "计量时间间隔配置 - MeterBaseTimeSpaceController")
public class MeterBaseTimeSpaceController extends BaseRESTfulController {

    @Autowired
    IMeterBaseTimeSpaceService meterBaseTimeSpaceService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasetimespace:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseTimeSpace> list = meterBaseTimeSpaceService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasetimespace:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseTimeSpace> list = meterBaseTimeSpaceService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseTimeSpace对象创建")
    @ApiImplicitParam(name = "meterBaseTimeSpace", value = "详细实体meterBaseTimeSpace", required = true, dataType = "MeterBaseTimeSpace")
    //@RequiresPermissions("meterbasetimespace:create")
    @Transactional
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseTimeSpace model) {
        try {
            String msg = meterBaseTimeSpaceService.checkandadd(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasetimespace:view")
    @Transactional
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseTimeSpace meterBaseTimeSpace = meterBaseTimeSpaceService.getById(id);
            return success(meterBaseTimeSpace);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseTimeSpace信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseTimeSpace", value = "详细实体meterBaseTimeSpace", required = true, dataType = "MeterBaseTimeSpace")
    })
    //@RequiresPermissions("meterbasetimespace:update")
    @Transactional
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseTimeSpace model) {
        try {
            String msg = meterBaseTimeSpaceService.checkandupdate(id, model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasetimespace:delete")
    @PutMapping(value = "/")//String
    public RESTfulResult delete(@RequestBody List<MeterBaseTimeSpace> models) {
        try {
            List<String> list = new ArrayList<String>();
            for (MeterBaseTimeSpace model : models) {
                String id = model.getId();
                list.add(id);
            }
            List<String> ids = ListUtils.convertList(list);
            meterBaseTimeSpaceService.delete(ids);
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
